# -*- coding: UTF-8 -*-
#   icd_plot.py     2024.1.24   kita

#!! Plot Out スクリプト

#   // 履歴 //
# 2024.2.27 印刷範囲情報のないファイルを最後に処理すると無限ループに陥るのを修正
# 2024.3.25 **all_ext.pdfにおいて複数のプロット情報をもつファイルの並びが不適切なのを修正



# ICADを操るためのおまじない
import clr
clr.AddReference('sxnet')
from sxnet import *

import tkinter as tk
#from tkinter import *
from tkinter import messagebox
import tkinter.ttk as ttk       # ComboBoxを使うのに必要

import numpy as np
import icd_module as imd
#import icd_module as imd
#import my_vector as myv
import my_module as mmd
import my_tk as mtk

import os
#import threading
#from time import sleep
import sys
import subprocess
import shutil
import time
import glob
import codecs

my_fn= os.path.basename(__file__)       # icd_plot.py
save_fn= my_fn.replace('.py','.dat')    # icd_plot.dat
icad_path= SxSys.getDir().replace('\\','/')    # c:/ICADSX
my_save_fn= icad_path+ '/'+ save_fn      # c:/ICADSX/icd_plot.dat 
#target_fld= 'c:/zip/'   # 一括印刷対象フォルダー初期値'
#TIF_fld= 'c:/tmp_TIF/' # 

#Editorの設定  editor   エディター
edit_fn = 'editor.ini'
if os.path.exists(edit_fn):      # fnが存在するなら
    fp = open(edit_fn, 'r')
    for line in fp.readlines():
        if line.find('#') > -1:  # #が含まれてるなら
            continue
        line = line.rstrip()    # 行末の改行を削除
        tmp = line.split(',')
        if tmp[0] == 'editor':
            editor = tmp[1]
else:
    editor = 'notepad'


#----------------------------------
#   プロッター情報取得
#----------------------------------
plot_list= SxInfPlot.getInfPlotList()
plot_name_list= []
print('// 登録プロッタ //')
for plot in plot_list:
    print('     No:%8s  名前: %s' % (plot.no,plot.name))
    plot_name_list.append(plot.name)
    # Bullzip Ploter No取得
    if plot.name.find('Bullzip')> -1 or plot.name.find('bullzip')> -1 :
        Bullzip_no= plot.no[-2:]
#print('Bullzip_no= %s' % Bullzip_no)

#------------------------------------------------
#   Bullzip setting.ini より保存先フォルダー取得
#------------------------------------------------
Bullzip_ini_fn= 'C:/Users/acad/AppData/Roaming/PDF Writer/Bullzip PDF Printer/settings.ini'
if os.path.exists(Bullzip_ini_fn):
    with codecs.open(Bullzip_ini_fn,"r","UTF-16LE") as fp:
        lines= fp.readlines()
        for line in lines:
            #print(line)
            if line.find(' output=') > -1:
                tmp= line.split('=')
                #print(tmp)
                out_put=tmp[1].rstrip()
                break
    pdf_save_path= os.path.dirname(out_put)
    pdf_save_path= pdf_save_path.replace('\\','/')
    gs_path='C:/Program Files/Bullzip/PDF Printer/gs'
    #gs_path='C:\Program Files\Bullzip\PDF Printer\gs'
    Ghost= True

else:
    mtk.warning('\n     Bullzipがインストールされていないようです')
    pdf_save_path= 'None'


#-------------------------
#   ヘルプ
#-------------------------
def push_help():    # 開発Versionでも同じヘルプを開く
    (fn, ext) = os.path.splitext(my_fn)
    if fn[-1] == '_':
        fn= fn[:-1]
    cmd= '%s %s.txt' % (editor, fn)
    result = subprocess.Popen(cmd,shell=True)
    
   
#-------------------------
#   Bullzip option編集
#-------------------------
def push_Bullzip():
    cmd= 'C:\Program Files\Bullzip\PDF Printer\gui.exe'
    result = subprocess.Popen(cmd,shell=True)

def get_parameter():
    # 印刷サイズ
    A1_size= cmb1.get()
    A2_size= cmb2.get()
    A3_size= cmb3.get()
    #A4_size= 'A4'
    # Ploter Number
    plt_num= cmb4.current()+1
    plt_name= cmb4.get()
    
    return (A1_size, A2_size, A3_size, plt_num, plt_name) 

def push_exe0(): # Active Model 印刷実行
    (A1_size, A2_size, A3_size, plt_num, plt_name)= get_parameter()
    #print(A1_size, A2_size, A3_size, plt_num, plt_name)
    (mdl_name, mdl_path, mdl_fp_fn)= imd.get_active_model_name() # Activeなモデルの model
    set_entry2(entry0, (mdl_name+'.icd'))

    #model_check()
    model= SxModel.getActive()
    printinf= model.getInfPrintList()   # 出図範囲情報
    if printinf== None:
        ss= '%s.icd に印刷範囲情報がありません\n(保存されてないのかもしれません)' % mdl_name
        mtk.warning(ss)
        return

    nn= len(printinf)   # 出図範囲情報数
    cnt= 1
    for inf in printinf:    # 出図範囲情報 Listより
        area_num= inf.no
        if inf.size== 'A1':
            plt_size= A1_size
        elif inf.size== 'A2':
            plt_size= A2_size
        elif inf.size== 'A3':
            plt_size= A3_size
        else: # A4
            plt_size= 'A4T'

        ang= 0.0    # 角度 0.0 90.0 180.0 270.0
        if cnt== 1:
            print(mdl_fp_fn, plt_num, plt_size, ang)    ##### 
            #plot_exe(mdl_fp_fn, plt_num, 0, plt_size, ang)  # 全ての印刷範囲を印刷
            plot_exe(mdl_fp_fn, plt_num, area_num, plt_size, ang)
            cnt+= 1
        else:
            res= mtk.question_yn('%d/%d 枚目を印刷しますか' % (cnt,nn)) 
            if res:
                if plt_name.find('PDF')> -1: # PDF
                    fn_ext = os.path.basename(mdl_fp_fn)    # 81029712004.icd
                    (fn, ext) = os.path.splitext(fn_ext)    # 81029712004, icd
                    tmp1= '%s/%s.pdf' % (pdf_save_path, fn)
                    tmp2= '%s/%s_%d.pdf' % (pdf_save_path, fn, (cnt-1))
                    #print(tmp1, tmp2)
                    if os.path.exists(tmp1):
                        shutil.move(tmp1, tmp2)
                #print(mdl_fp_fn, plt_num, area_num, plt_size, ang)
                plot_exe(mdl_fp_fn, plt_num, area_num, plt_size, ang)
                print(cnt, nn)
                if cnt== nn:   #最後のPlot No
                    time.sleep(1)
                    #tmp1= '%s/%s.pdf' % (pdf_save_path, fn)
                    tmp2= '%s/%s_%d.pdf' % (pdf_save_path, fn, cnt)
                    #print(tmp1, tmp2)
                    #if os.path.exists(tmp1):
                    shutil.move(tmp1, tmp2)

            cnt+= 1

def push_exe01(): # Active Model 確認
    model_check()


def push_exe1(): #外部パーツ一括PDF(Modelを開かない)
    SxSys.setDim(True) #3Dに切り替え 3D切り替え
    wf = SxWF.getActive()         # Activeな3D空間のwfインスタンス作成
    tree = wf.getInfPartTree()    # Tree View 情報取得 
    #fn_list = []  #Gloval 初期化
    # 全階層パーツファイル名(Full Path)を取得する。fn_list(fp_fn_list)
    ext_idx= 1; fn_list= [] 
    imd.get_ext_parts_list(tree, 0, fn_list, ext_idx)
    fn_list1= sorted(set(fn_list))  # 重複を削除してソートしたリストを返す
    
    for fn in fn_list1:
        plot_inf= imd.get_plot_inf(icad_path, fn, mode= 0)
        #print(plot_inf) #####
        # 印刷範囲情報が無い
        if plot_inf== None:
            print('     %sに印刷範囲情報がありません' % fn)
            continue
        nn= len(plot_inf)
        cnt= 1
        for inf in plot_inf:    # 複数の印刷情報を順次処理 
            if cnt> 1:  # 複数なら
                fn_ext= os.path.basename(fn)    # 81029712007.icd
                (fn0, ext)= os.path.splitext(fn_ext)    # 81029712007, icd
                tmp1= '%s/%s.pdf' % (pdf_save_path, fn0)
                ###########################################################
                tmp2= '%s/%s_%d.pdf' % (pdf_save_path, fn0, pre_area)
                #tmp2= '%s/%s_%d.pdf' % (pdf_save_path, fn, (cnt-1))
                #print(tmp1, tmp2)
                while True:
                    if os.path.exists(tmp1):
                        time.sleep(0.5)
                        shutil.move(tmp1, tmp2) # 事前のファイル名にPlot No.を付加する
                    if os.path.exists(tmp2):
                        break
                #result = subprocess.call('shutil.move(tmp1, tmp2)',shell=False)
                #result.wait()
            cmd= '%s/bin/SXPLOT.exe %s %s -F %d' % (icad_path, fn, Bullzip_no, inf[0])
            #print(cmd)
            try:
                result= subprocess.Popen(cmd, shell=False)        
                #result= subprocess.Popen(cmd, shell=True)
                result.wait()
                #print(cnt, nn)
            except:
                print('%s をスキップします' % fn)
                continue
            if nn> 1 and cnt== nn:   #最後のPlot No
                time.sleep(1)
                tmp2= '%s/%s_%d.pdf' % (pdf_save_path, fn0, cnt)
                shutil.move(tmp1, tmp2)

            pre_area= inf[0]
            cnt+= 1

    # PDF 結合
    mdl_name, mdl_path, mdl_fp_fn = imd.get_active_model_name()
    out_fn= '%s/%s_allext.pdf' % (pdf_save_path, mdl_name) # plot_test_ext.pdf
    #out_fn= '%s\\%s_ext.pdf' % (pdf_save_path, mdl_name) # plot_test_ext.pdf
    if Ghost:   # Ghost Script install済み
        ss= '結合PDF File %s を作成しますか' % out_fn 
        if not mtk.question_yn(ss):
            return
    else:
        return

    # PDF出力完了確認  印刷範囲情報がないとまずい
    #while True:
    #    fn_ext = os.path.basename(fn)    # 81029712004.icd
    #    tmp0= fn_ext.replace('icd', 'pdf')      # 81029712008.pdf
    #    tmp1= '%s/%s' % (pdf_save_path, tmp0)
    #    if not os.path.exists(tmp1):
    #        time.sleep(1)
    #        continue
    #    break
    time.sleep(2)

    pdf_list= glob.glob('%s/*.pdf' % pdf_save_path)     
    cmd= '%s/gswin64c -q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sOutputFile=%s' % (gs_path, out_fn) 
    for pdf in pdf_list:
        cmd= cmd+ ' '+ pdf
    #print(cmd)
    result= subprocess.Popen(cmd, shell=False)
    result.wait()   # subprocess 終了確認

    # 他のPDF削除
    if mtk.question_yn('結合したPDFを削除しますか'):
        for pdf in pdf_list:
            os.remove(pdf)       # ファイルを削除する
    if mtk.question_yn('%sを開きますか' % out_fn):
        result = subprocess.Popen(out_fn,shell=True)



def push_exe2(): # 一括TIF変換
    pdf_list= glob.glob('%s/*.pdf' % pdf_save_path)     
    for pdf in pdf_list:
        tif_fn= pdf.replace('pdf', 'tif')
        cmd= '%s/gswin64c -q -dNOPAUSE -dBATCH -sDEVICE=tiffg4 -r600 -sOutputFile=%s %s' % (gs_path,tif_fn, pdf)
        print(cmd)
        result= subprocess.Popen(cmd, shell=False)
        result.wait()   # subprocess 終了確認

    if mtk.question_yn('%sを開きますか' % tif_fn):
        result = subprocess.Popen(tif_fn,shell=True)

     


def plot_exe(fp_fn, plt_num, area_num, plt_size, ang):
    #   ファイル名, PloterNo 0*, 範囲番号
    #printinf= model.getInfPrintList() # 出図test_subprocess.py範囲枠情報
    if plt_size== 'A1':
        x= 841; y= 594
    elif plt_size== 'A2':
        x= 594; y= 420
    elif plt_size== 'A3':
        x= 420; y= 297
    elif plt_size== 'A4T':
        x= 210; y= 297
    elif plt_size== 'A4':
        x= 297; y= 210
    if area_num== 0:
        cmd= '%s/bin/SXPLOT.exe %s 0%d -S %d,%d -A %d' % (icad_path, fp_fn, plt_num, x, y, ang)
    else:
        cmd= '%s/bin/SXPLOT.exe %s 0%d -F %d -S %d,%d -A %d' % (icad_path, fp_fn, plt_num, area_num, x, y, ang)
    #cmd= 'c:/ICADSX/bin/SXPLOT.exe %s 03 -F 1' % fp_fn # PDFはサイズ指定不要

    #print(cmd)
    result= subprocess.Popen(cmd, shell=True)
    result.wait()   # subprocess 終了確認

def push_exe3():
    out_fn= 'all_joint.pdf'
    out_fp_fn= '%s/%s' % (pdf_save_path,out_fn)
    cmd= '%s/gswin64c -q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sOutputFile=%s' % (gs_path, out_fp_fn) 
    pdf_list= glob.glob('%s/*.pdf' % pdf_save_path)
    cnt= 0
    for pdf in pdf_list:
        cmd= cmd+ ' '+ pdf
        cnt+= 1
    
    result= subprocess.Popen(cmd, shell=False)
    result.wait()   # subprocess 終了確認

    mtk.information('%d 個のPDFファイルを %s に結合しました。' % (cnt, out_fn)) 


def set_data():     # save_fnよりEntry ComboBox値を読み込んで書き込み
    with open(my_save_fn, 'r') as fp:
        lines = fp.readlines()
    #i= 0
    for line in lines:
        line = line.rstrip()    # 行末の改行削除
        if line.find('#') > -1:  # #が含まれてるなら
            continue

        tmp= line.split('= ')
        if line.find('target_fld') > -1:
            target_fld= tmp[1]
            set_entry2(entry1, tmp[1])
        elif line.find('cmb1') > -1: # A1出図サイズ
            cmb1.current(int(tmp[1]))
        elif line.find('cmb2') > -1: # A2出図サイズ
            cmb2.current(int(tmp[1]))
        elif line.find('cmb3') > -1: # A3出図サイズ
            cmb3.current(int(tmp[1]))
        elif line.find('cmb4') > -1: # プロッタ選択
            cmb4.current(int(tmp[1])) 

def save_data():    #  設定値保存
    ss= ''
    ss= ss+ 'cmb1= %d\n' % cmb1.current()   # A1出図サイズ
    ss= ss+ 'cmb2= %d\n' % cmb2.current()   # A2出図サイズ
    ss= ss+ 'cmb3= %d\n' % cmb3.current()   # A3出図サイズ
    ss= ss+ 'cmb4= %d\n' % cmb4.current()   # Plot Number

    ss= ss+ 'target_fld= %s' % entry1.get() 

    with open(my_save_fn,'w') as fp:
        fp.write(ss)

#def set_entry(idx, ss): # Entryに文字列を挿入
#    entry[idx].delete(0,tk.END)
#    entry[idx].insert(0,ss)

def set_entry2(ent, ss): # Entryに文字列を挿入
    ent.delete(0,tk.END)
    ent.insert(0,ss)


def model_check():
    #global mdl_fp_fn    # Full Path Active Model Name
    (mdl_name, mdl_path, mdl_fp_fn)= imd.get_active_model_name() # Activeなモデルの model
    
    if mdl_name!= None:
        set_entry2(entry0, (mdl_name+'.icd'))
    else:
        set_entry2(entry0, 'モデルがありません')
    #return (mdl_name+'.icd')    

def on_closing():       # 終了時の処理
    save_data()
    ss_geom = root.geometry() 
    mmd.save_geometry(save_fn_geom, ss_geom)

    #print('\n   %s を終了しました\n' % tmp_fn)
    print('\n   %s を終了しました\n' % my_fn)

    root.destroy()


#************************************
# ボタン等の部品配置
#************************************
#nl = 10
root = tk.Tk()
root.attributes("-topmost", True)    # 常に前面に表示
root.configure(bg='RoyalBlue4')
root.title(my_fn)  #タイトル
save_fn_geom = my_fn.replace('.py', '.ini')
ss_geom = mmd.read_geometry(save_fn_geom)
if ss_geom == None:
    ss_geom = '200x230+1000+0'

root.geometry(ss_geom)

btn_bcol = 'grey21'     #ボタン背景色
btn_tcol = 'white'      #ボタン文字色
label_bcol = 'khaki3'   #ラベル背景色
label_tcol = 'black'    #ラベル文字色
e_bcol = 'ivory2'       #Entry背景色

x0= 2; y0= 2
#dx= 100; dy= 22
px= 2; py= 2
ie=0

#entry= []
#--------------------------------------------------------
# Frame1 Active Model印刷サイズ Combobox cmb1-3 
#--------------------------------------------------------
frame1 = tk.LabelFrame(root, text='ActiveModel サイズ指定印刷', padx=px, pady=py,bg="RoyalBlue3",fg=btn_tcol) 
frame1.place(x=x0,y=y0)
# A1
v_cmb1= tk.StringVar()
label1= tk.Label(frame1,text='A1', bg=label_bcol)
label1.grid(column=0,row=0, padx=px, pady=py)    # colum:x row:y
cmb1= ttk.Combobox(frame1, width=3, textvariable= v_cmb1)
#cmb1.bind('<<ComboboxSelected>>', cmb1_selected)
cmb1['values']=('A3', 'A4')
cmb1.current(0)   # cb初期設定 Default
cmb1.grid(column=1,row=0,padx=px, pady=py)   # colum:x row:y
# A2
v_cmb2= tk.StringVar()
label2= tk.Label(frame1,text='A2', bg=label_bcol)
label2.grid(column=0,row=1, padx=px, pady=py)    # colum:x row:y
cmb2= ttk.Combobox(frame1, width=3, textvariable= v_cmb2)
#cmb2.bind('<<ComboboxSelected>>', cmb2_selected)
cmb2['values']=('A3', 'A4')
cmb2.current(0)   # cb初期設定 Default
cmb2.grid(column=1,row=1,padx=px, pady=py)   # colum:x row:y
# A3
v_cmb3= tk.StringVar()
label3= tk.Label(frame1,text='A3', bg=label_bcol)
label3.grid(column=0,row=2, padx=px, pady=py)    # colum:x row:y
cmb3= ttk.Combobox(frame1, width=3, textvariable= v_cmb3)
#cmb3.bind('<<ComboboxSelected>>', cmb3_selected)
cmb3['values']=('A3', 'A4')
cmb3.current(1)   # cb初期設定 Default
cmb3.grid(column=1,row=2,padx=px, pady=py)   # colum:x row:y
# Active Model name Entry0
entry0= tk.Entry(frame1, width=17,justify="right",bg=e_bcol)
entry0.grid(column= 2, row= 0, padx=px, pady=py)
# Ploter選択ComboBox
v_cmb4= tk.StringVar()
cmb4= ttk.Combobox(frame1, width=15, textvariable= v_cmb4)
#cmb4.bind('<<ComboboxSelected>>', cmb4_selected)
cmb4['values']=(plot_name_list)
cmb4.current(0)   # cb初期設定 Default
cmb4.grid(column= 2, row= 1, padx=px, pady=py)   # colum:x row:y

btn= tk.Button(frame1,text= 'Act確認',command= push_exe01,bg=btn_bcol,fg=btn_tcol)
btn.place(x= 70, y= 50)
#btn.grid(column= 2, row= 2, padx=px, pady=py)   # colum:x row:y

btn= tk.Button(frame1,text= '印刷実行',command= push_exe0,bg=btn_bcol,fg=btn_tcol)
btn.place(x= 125, y= 50)
#btn.grid(column= 2, row= 2, padx=px, pady=py)   # colum:x row:y

#-------------------------------------------
# Frame2 外部パーツ一括PDF
#-------------------------------------------
frame2 = tk.LabelFrame(root, text='外部パーツ一括PDF', \
        padx=px, pady=py,bg="RoyalBlue3",fg=btn_tcol) 
frame2.place(x=x0,y=y0+110)
# PDF保存先 Entr1
entry1= tk.Entry(frame2, width=16,justify="right",bg=e_bcol)
entry1.grid(column= 0, row= 0, padx=px, pady=py)
#set_entry2(entry1,pdf_save_path)
label= tk.Label(frame2,text='へ保存',bg=label_bcol)
label.grid(column= 1, row= 0, padx=px, pady=py)   # colum:x row:y
# 一括PDF変換実行ボタン 
btn= tk.Button(frame2,text= '実行',command= push_exe1,bg=btn_bcol,fg=btn_tcol)
btn.grid(column= 2, row= 0, padx=px, pady=py)   # colum:x row:y
# 一括TIF変換実行ボタン 
btn_pdf2tif= tk.Button(frame2,text= 'PDF->Tif変換実行',command= push_exe2, bg=btn_bcol,fg=btn_tcol)
btn_pdf2tif.grid(column= 0, row= 1, padx=px, pady=py)   # colum:x row:y
if not Ghost:   # Ghost Script未インストール
    btn_pdf2tif['state'] = 'disabled'

# PDF結合実行ボタン 
btn_pdfJ= tk.Button(frame2,text= 'PDF結合',command= push_exe3, bg=btn_bcol,fg=btn_tcol)
#btn_pdfJ.grid(column= 1, row= 1, padx=px, pady=py)   # colum:x row:y
btn_pdfJ.place(x=110,y=32)


#---------------------------------------------------
# ヘルプ Button
#---------------------------------------------------
btn_help = tk.Button(root,text = 'ヘルプ',command = push_help,bg=btn_bcol,fg=btn_tcol) 
btn_help.place(x=x0+150,y=y0+200)

#---------------------------------------------------
# Bullzip Option 編集
#---------------------------------------------------
btn_help = tk.Button(root,text = ' BullzipOption編集',command = push_Bullzip,bg=btn_bcol,fg=btn_tcol) 
btn_help.place(x=x0+30,y=y0+200)


#--------------------------------
#   起動時の処理
#--------------------------------
# icd_plot.datがあれば読み込んでパラメータセット
if os.path.exists(my_save_fn) == True:
    set_data()

#if cmb0.current()== 0:
model_check()
set_entry2(entry1,pdf_save_path)
#else: # 一括印刷
#    set_entry2(entry0, target_fld)


root.protocol("WM_DELETE_WINDOW", on_closing)
root.mainloop()
